Foxit PDF SDK

Public Member Functions | List of all members
foxit::pdf::interform::Form Class Reference
Inheritance diagram for foxit::pdf::interform::Form:

## Public Member Functions
| Form (const Form &other)
| Constructor, with another form object. More...
| Form (const pdf::PDFDoc &document)
| Constructor, with PDF document. More...
| ~Form ()
| Destructor.
Control | AddControl (const PDFPage &page, const wchar_t *field_name, Field::Type field_type, const RectF &rect)
| Add a new form control to a specified form field. If the form field does not exist, this function will add a form field as well. (Not support signature field) More...
bool | ExportToCSV (const wchar_t *csv_file_path, const wchar_t *pdf_file_name, bool is_append)
| Export the form data to a CSV file. More...
bool | ExportToCSV (foxit::common::file::StreamCallback *csv_file, const wchar_t *pdf_file_name, bool is_append)
| Export the form data to a CSV file. More...
bool | ExportToHTML (const wchar_t *html_file_path, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to an HTML file. More...
bool | ExportToHTML (foxit::common::file::WriterCallback *html_file, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to an HTML file. More...
bool | ExportToTXT (const wchar_t *txt_file_path, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to a TXT file. More...
bool | ExportToTXT (foxit::common::file::WriterCallback *txt_file, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to a TXT file. More...
bool | ExportToXML (const char *file_path)
| Export the form data to an XML file. More...
bool | ExportToXML (const wchar_t *file_path, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to an XML file. More...
bool | ExportToXML (foxit::common::file::WriterCallback *xml_file, const FieldArray &field_array, bool is_include)
| Export data of specified form fields to an XML file. More...
void | FixPageFields (int page_index)
| Fix the fields which are in a PDF page but cannot be counted by current form object. More...
common::Alignment | GetAlignment () const
| Get the alignment value which is used as document-wide default value. More...
Control | GetControl (const PDFPage &page, int index)
| Get a form control by index, in a specified PDF page. More...
Control | GetControlAtDevicePoint (const PDFPage &page, const PointF &point, float tolerance, Field::Type type, const Matrix *matrix=0)
| Get the form control at a specified position, in device coordinate system. More...
Control | GetControlAtPoint (const PDFPage &page, const PointF &point, float tolerance, Field::Type type)
| Get the form control at a specified position, in PDF coordinate system. More...
int | GetControlCount (const PDFPage &page) const
| Get count of form controls in a specified PDF page. More...
DefaultAppearance | GetDefaultAppearance () const
| Get the default appearance data. More...
objects::PDFDictionary * | GetDict () const
| Get the dictionary of current object. More...
PDFDoc | GetDocument () const
| Get the PDF document, with which current form object is associated. More...
Field | GetField (int index, const wchar_t *filter=0)
| Get a form field by index, whose names satisfy the specified name filter. More...
int | GetFieldCount (const wchar_t *filter=0) const
| Get the count of form fields, whose names satisfy the specified name filter. More...
FieldArray | GetFieldsInCalculationOrder ()
| Get an array of form fields in calculation order. More...
Filler | GetFormFiller () const
| Get the form filler. More...
bool | ImportFromXML (const char *file_path)
| Import the form data from an XML file. More...
bool | IsEmpty () const
| Check whether current object is empty or not. More...
bool | MoveControl (Control &control, const wchar_t *field_name)
| Move the control to a field specified by field name. More...
bool | NeedConstructAppearances () const
| Check whether to construct appearance when loading form controls. More...
bool | operator!= (const Form &other) const
| Not equal operator. More...
Form & | operator= (const Form &other)
| Assign operator. More...
bool | operator== (const Form &other) const
| Equal operator. More...
void | RemoveControl (Control &control)
| Remove a form control. (Not support to remove a form control from a signature field) More...
void | RemoveField (Field &field)
| Remove a form field. (Not support signature field) More...
bool | RenameField (Field &field, const wchar_t *new_field_name)
| Rename a field with a new name. More...
bool | Reset ()
| Reset data of all fields (except signature fields) to their default value. More...
void | SetAlignment (common::Alignment alignment)
| Set alignment value which is used as document-wide default value. More...
void | SetConstructAppearances (bool need_construct)
| Set a flag that specifies whether to construct appearances when loading form controls. More...
void | SetDefaultAppearance (const DefaultAppearance &default_ap)
| Set default appearance data. More...
void | SetFieldsInCalculationOrder (const FieldArray &field_array)
| Set an array of form fields in calculation order. More...
bool | ValidateFieldName (Field::Type type, const WString &field_name)
| Validate whether a field name can be used for a new field in specified field type. More...
Public Member Functions inherited from foxit::Base
FS_HANDLE | Handle () const
| Get the handle of current object. More...

## Detailed Description

An interactive form – sometimes referred to as an AcroForm – is a collection of fields for gathering information interactively from the user. A PDF document may contain any number of fields appearing on any combination of pages, all of which make up a single, global interactive form spanning the entire document. Arbitrary subsets of these fields can be imported or exported from the document.
Function pdf::PDFDoc::HasForm can be used to judge if a PDF document has interactive form.
A form object can be constructed form a specified PDF document. This class offers functions to retrieve form fields or form controls, import/export form data and other features. For example:

- To retrieve form fields, please use functions Form::GetFieldCount and Form::GetField.
- To retrieve form controls from a PDF page, please use functions Form::GetControlCount and Form::GetControl.
- To import form data from an XML file, please use function Form::ImportFromXML; to export form data to an XML file, please use function Form::ExportToXML.
- To retrieve form filler object, please use function Form::GetFormFiller.

To import form data from a FDF/XFDF file or export such data to a FDF/XFDF file, please refer to functions pdf::PDFDoc::ImportFromFDF and pdf::PDFDoc::ExportToFDF.
To fill the form, please construct a form filler object by current form object or retrieve the filler object by function Form::GetFormFiller if such object has been constructed. (There should be only one form filler object for an interactive form).

See also
  pdf::PDFDoc
  Filler

## Constructor & Destructor Documentation

## ◆ Form() [1/2]

foxit::pdf::interform::Form::Form | ( | const pdf::PDFDoc & | document | ) |
| explicit

Constructor, with PDF document.

If PDF document does not have AcroForm, this constructor will add an empty AcroForm to the PDF document in order that new fields can be added to the PDF document later.

Parameters

  [in] | document | A valid PDF document.

## ◆ Form() [2/2]

foxit::pdf::interform::Form::Form | ( | const Form & | other | ) |

Constructor, with another form object.

Parameters

  [in] | other | Another form object.

## Member Function Documentation

## ◆ AddControl()

Control foxit::pdf::interform::Form::AddControl | ( | const PDFPage & | page,
|  | const wchar_t * | field_name,
|  | Field::Type | field_type,
|  | const RectF & | rect
| ) |  |

Add a new form control to a specified form field. If the form field does not exist, this function will add a form field as well. (Not support signature field)

Application can use this function to add a new form control:

- If the specified form field exists, a new form control will be created and set to the field.
- If the specified form field does not exist, a new form field will be created according to parameter field_name and field_type and added to form, along with a newly created form control.

Whether a form field exists or not, it will be judged with input parameters field_name and field_type.
If user wants to add a new signature field, please use function pdf::PDFPage::AddSignature instead of current function.
The newly added form control has no appearance, so user should use setting methods in class Control or in related pdf field or widget annotation to set properties which will affect appearance. Some setting methods of class interform::Control and Field may directly update appearance, but functionannots::Annot::ResetAppearanceStream of related widget annotation is still recommended to be called to ensure the appearance will indeed be updated.
For push button, check box, radio button, if user calls function annots::Annot::ResetAppearanceStream directly without setting any properties, the default appearance style will be used:

- push button: In related widget annotation, background color (in the MK dictionary) = 0xC0C0C0, highlighting mode = annots::Annot::e_HighlightingPush.
- check box/radio button: In related widget annotation, border width = 1.0, border style = annots::BorderInfo::e_Solid, background color (in the MK dictionary) = 0xFFFFFF, border color (in the MK dictionary) = 0xFFFFFF.

Parameters

  [in] | page | A valid PDF page, in which the new form control will be added. It should belong to the same PDF document as current form.
  [in] | field_name | Field name. It should not be an empty string.
  [in] | field_type | Field type. Please refer to values starting from Field::e_TypePushButton and this should be one of these values except Field::e_TypeSignature. If this is Field::e_TypeSignature, this function will throw exception foxit::e_ErrUnsupported.
  [in] | rect | Rectangle of the new form control which specifies the position in PDF page. It should be in PDF coordinate system.

Returns
  The newly added form control object.

## ◆ ExportToCSV() [1/2]

bool foxit::pdf::interform::Form::ExportToCSV | ( | const wchar_t * | csv_file_path,
|  | const wchar_t * | pdf_file_name,
|  | bool | is_append
| ) |  |

Export the form data to a CSV file.

Parameters

  [in] | csv_file_path | A full file path of a CSV file. This specifies the CSV file that form data will be exported to. This should not be an empty string.
  [in] | pdf_file_name | File name of current PDF document. This file name will be written into the CSV file. This can be an empty string.
  [in] | is_append | A boolean value used to decide whether the form data is appended to the CSV file if the CSV file exists: true means to append form data to an existed CSV file, while false means not.

Returns
  true means success, while false means failure.

## ◆ ExportToCSV() [2/2]

bool foxit::pdf::interform::Form::ExportToCSV | ( | foxit::common::file::StreamCallback * | csv_file,
|  | const wchar_t * | pdf_file_name,
|  | bool | is_append
| ) |  |

Export the form data to a CSV file.

Parameters

  [in] | csv_file | A common::file::StreamCallback object which is implemented by user to save form data to a CSV file. This should not be NULL. Please do not use append mode in writing callback functions.
  [in] | pdf_file_name | File name of current PDF document. This file name will be written into the CSV file. This can be an empty string.
  [in] | is_append | A boolean value used to decide whether the form data is appended to the CSV file if the CSV file exists: true means to append form data to an existed CSV file, while false means not.

Returns
  true means success, while false means failure.

## ◆ ExportToHTML() [1/2]

bool foxit::pdf::interform::Form::ExportToHTML | ( | const wchar_t * | html_file_path,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to an HTML file.

Parameters

  [in] | html_file_path | A full file path of an HTML file, to which data of specified form fields will be exported. This should not be an empty string.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToHTML() [2/2]

bool foxit::pdf::interform::Form::ExportToHTML | ( | foxit::common::file::WriterCallback * | html_file,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to an HTML file.

Parameters

  [in] | html_file | A common::file::WriterCallback object which is implemented by user to save data of specified form fields to an HTML file. This should not be NULL.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToTXT() [1/2]

bool foxit::pdf::interform::Form::ExportToTXT | ( | const wchar_t * | txt_file_path,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to a TXT file.

Parameters

  [in] | txt_file_path | A full file path of a TXT file, to which data of specified form fields will be exported. This should not be an empty string.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToTXT() [2/2]

bool foxit::pdf::interform::Form::ExportToTXT | ( | foxit::common::file::WriterCallback * | txt_file,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to a TXT file.

Parameters

  [in] | txt_file | A common::file::WriterCallback object which is implemented by user to save data of specified form fields to a TXT file. This should not be NULL.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToXML() [1/3]

bool foxit::pdf::interform::Form::ExportToXML | ( | const char * | file_path | ) |

Export the form data to an XML file.

Parameters

  [in] | file_path | A full file_path of an XML file. This specifies the XML file that form data will be exported to.

Returns
  true means success, while false means failure.

## ◆ ExportToXML() [2/3]

bool foxit::pdf::interform::Form::ExportToXML | ( | const wchar_t * | file_path,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to an XML file.

Parameters

  [in] | file_path | A full file_path of an XML file, to which data of specified form fields will be exported.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToXML() [3/3]

bool foxit::pdf::interform::Form::ExportToXML | ( | foxit::common::file::WriterCallback * | xml_file,
|  | const FieldArray & | field_array,
|  | bool | is_include
| ) |  |

Export data of specified form fields to an XML file.

Parameters

  [in] | xml_file | A common::file::WriterCallback object which is implemented by user to save data of specified form fields to an XML file. This should not be NULL.
  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not. If this is an empty array, that means data of all form fields would be exported.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.

Returns
  true means success, while false means failure.

## ◆ FixPageFields()

void foxit::pdf::interform::Form::FixPageFields | ( | int | page_index | ) |

Fix the fields which are in a PDF page but cannot be counted by current form object.

It may cost much time if there are many fields in the specified page.

Parameters

  [in] | page_index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc::GetPageCount.

Returns
  None.

## ◆ GetAlignment()

common::Alignment foxit::pdf::interform::Form::GetAlignment | ( |  | ) | const

Get the alignment value which is used as document-wide default value.

Alignment is a property for variable text. It is only applicable for text field, list box and combo box, which may contain variable text as their content.
If a text field or list box has its own alignment value, the document-wide default alignment value will be ignored; otherwise, the document-wide default value will be used for the text field or list box.

Returns
  The alignment value. Please refer to values starting from common::e_AlignmentLeft and this would be one of these values.

## ◆ GetControl()

Control foxit::pdf::interform::Form::GetControl | ( | const PDFPage & | page,
|  | int | index
| ) |  |

Get a form control by index, in a specified PDF page.

Parameters

  [in] | page | A valid PDF page object. It should belong to the same PDF document as current form.
  [in] | index | Index of form control to be retrieved. Valid range: from 0 to (count-1). count is returned by function Field::GetControlCount with same parameter page.

Returns
  A form control object.

## ◆ GetControlAtDevicePoint()

Control foxit::pdf::interform::Form::GetControlAtDevicePoint | ( | const PDFPage & | page,
|  | const PointF & | point,
|  | float | tolerance,
|  | Field::Type | type,
|  | const Matrix * | matrix = `0`
| ) |  |

Get the form control at a specified position, in device coordinate system.

Parameters

  [in] | page | A valid PDF page object. It should be in the same document as current form.
  [in] | point | A position, in device coordinate system.
  [in] | tolerance | Tolerance value. Valid range: 0.0f to 30.0f.
  [in] | type | The field type whose form control will be retrieved. Please refer to values starting from Field::e_TypeUnknown and this should be one of these values. Field::e_TypeUnknown means not to care about the field type and just to retrieve the first form control at the specified position.
  [in] | matrix | A transformation matrix. Usually this is returned by function pdf::PDFPage::GetDisplayMatrix. If this is NULL, current function will have the same feature as function Form::GetControlAtPoint. Default value: NULL.

Returns
  A form control object. If the return value of function Control::IsEmpty for the returned form control object is true, that means no suitable form control is around the specified position.

## ◆ GetControlAtPoint()

Control foxit::pdf::interform::Form::GetControlAtPoint | ( | const PDFPage & | page,
|  | const PointF & | point,
|  | float | tolerance,
|  | Field::Type | type
| ) |  |

Get the form control at a specified position, in PDF coordinate system.

Parameters

  [in] | page | A valid PDF page object. It should be in the same document as current form.
  [in] | point | A position, in PDF coordinate system.
  [in] | tolerance | Tolerance value. Valid range: 0.0f to 30.0f.
  [in] | type | The field type whose form control will be retrieved. Please refer to values starting from Field::e_TypeUnknown and this should be one of these values. Field::e_TypeUnknown means not to care about the field type and just to retrieve the first form control at the specified position.

Returns
  A form control object. If the return value of function Control::IsEmpty for the returned form control object is true, that means no suitable form control is around the specified position.

## ◆ GetControlCount()

int foxit::pdf::interform::Form::GetControlCount | ( | const PDFPage & | page | ) | const

Get count of form controls in a specified PDF page.

Parameters

  [in] | page | A valid PDF page object. It should belong to the same PDF document as current form.

Returns
  The count of the form controls in the specified PDF page.

## ◆ GetDefaultAppearance()

DefaultAppearance foxit::pdf::interform::Form::GetDefaultAppearance | ( |  | ) | const

Get the default appearance data.

Returns
  The default appearance data.

## ◆ GetDict()

objects::PDFDictionary* foxit::pdf::interform::Form::GetDict | ( |  | ) | const

Get the dictionary of current object.

Returns
  The dictionary of current object. If there is any error, this function will return NULL.

## ◆ GetDocument()

PDFDoc foxit::pdf::interform::Form::GetDocument | ( |  | ) | const

Get the PDF document, with which current form object is associated.

Returns
  A PDF document object.

## ◆ GetField()

Field foxit::pdf::interform::Form::GetField | ( | int | index,
|  | const wchar_t * | filter = `0`
| ) |  |

Get a form field by index, whose names satisfy the specified name filter.

Parameters

  [in] | index | Index of form field to be retrieved. Valid range: from 0 to (count-1). count is returned by function Form::GetFieldCount with same parameter filter.
  [in] | filter | A filter string. If this is an empty string, that means to count all form fields; if this is valid, that means to count those form fields whose names are partially matched parameter filter. For example, if parameter filter is "text1", the filter will match text1.0, text1.2.0, etc; but not match test10 or test11.1. Default value: an empty string.

Returns
  A form field object.

## ◆ GetFieldCount()

int foxit::pdf::interform::Form::GetFieldCount | ( | const wchar_t * | filter = `0` | ) | const

Get the count of form fields, whose names satisfy the specified name filter.

Parameters

  [in] | filter | A filter string. If this is an empty string, that means to count all form fields; if this is valid, that means to count those form fields whose names are partially matched parameter filter. For example, if parameter filter is "text1", the filter will match text1.0, text1.2.0, etc; but not match test10 or test11.1. Default value: an empty string.

Returns
  The count of the form fields with specified name filter.

## ◆ GetFieldsInCalculationOrder()

FieldArray foxit::pdf::interform::Form::GetFieldsInCalculationOrder | ( |  | ) |

Get an array of form fields in calculation order.

The calculation order defines the order in which the values of fields will be recalculated when value of any field is changed. Usually, these fields have calculation actions.

Returns
  An array of form field in calculation order.

## ◆ GetFormFiller()

Filler foxit::pdf::interform::Form::GetFormFiller | ( |  | ) | const

Get the form filler.

Returns
  The filler object. If the return value of function Filler::IsEmpty for the returned filler object is true, that means form filler has not been constructed yet. For this case, please construct a filler with current form.

## ◆ ImportFromXML()

bool foxit::pdf::interform::Form::ImportFromXML | ( | const char * | file_path | ) |

Import the form data from an XML file.

Parameters

  [in] | file_path | A full file_path of an existing XML file. This specifies the XML file that form data will be imported from.

Returns
  true means success, while false means failure.

## ◆ IsEmpty()

bool foxit::pdf::interform::Form::IsEmpty | ( |  | ) | const

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ MoveControl()

bool foxit::pdf::interform::Form::MoveControl | ( | Control & | control,
|  | const wchar_t * | field_name
| ) |  |

Move the control to a field specified by field name.

Operation of current function for different cases:

- If the field specified by field name does not exist, a new field will be created with the field name and the control will be moved to this new field.
- If the field specified by field name exists and the field type is same as the field that control currently belongs to, the control will be combined into this field.
- If the field specified by field name exists but the field type is different from the field that control currently belongs to, this function will throw exception foxit::e_ErrConflict.

Parameters

  [in] | control | A valid form control object.
  [in] | field_name | A field name. It should not be an empty string.

Returns
  true means success, while false means failure.

## ◆ NeedConstructAppearances()

bool foxit::pdf::interform::Form::NeedConstructAppearances | ( |  | ) | const

Check whether to construct appearance when loading form controls.

Returns
  true means to construct appearances when loading form controls, while false means not.

## ◆ operator!=()

bool foxit::pdf::interform::Form::operator!= | ( | const Form & | other | ) | const

Not equal operator.

Parameters

  [in] | other | Another other object. This function will check if current object is not equal to this one.

Returns
  true means not equal, while false means equal.

## ◆ operator=()

Form& foxit::pdf::interform::Form::operator= | ( | const Form & | other | ) |

Assign operator.

Parameters

  [in] | other | Another form object, whose value would be assigned to current object.

Returns
  Reference to current object itself.

## ◆ operator==()

bool foxit::pdf::interform::Form::operator== | ( | const Form & | other | ) | const

Equal operator.

Parameters

  [in] | other | Another other object. This function will check if current object is equal to this one.

Returns
  true means equal, while false means not equal.

## ◆ RemoveControl()

void foxit::pdf::interform::Form::RemoveControl | ( | Control & | control | ) |

Remove a form control. (Not support to remove a form control from a signature field)

If the specified form control is the only form control of related form field, the related form field will be removed as well.

Parameters

  [in] | control | A form control to be removed. If the field type of related form field is Field::e_TypeSignature, this function will throw exception foxit::e_ErrUnsupported.

Returns
  None.

## ◆ RemoveField()

void foxit::pdf::interform::Form::RemoveField | ( | Field & | field | ) |

Remove a form field. (Not support signature field)

If the form field appears on more than one PDF page, all representations will be removed.
If user wants to remove a signature field, please use function pdf::PDFDoc::RemoveSignature instead of current function.

Parameters

  [in] | field | A form field to be removed. If the field type is Field::e_TypeSignature, this function will throw exception foxit::e_ErrUnsupported.

Returns
  None.

## ◆ RenameField()

bool foxit::pdf::interform::Form::RenameField | ( | Field & | field,
|  | const wchar_t * | new_field_name
| ) |  |

Rename a field with a new name.

Parameters

  [in] | field | A valid form field object.
  [in] | new_field_name | A new field name. It should not be an empty string.

Returns
  true means success, while false means failure.

## ◆ Reset()

bool foxit::pdf::interform::Form::Reset | ( |  | ) |

Reset data of all fields (except signature fields) to their default value.

Returns
  true means success, while false means failure.

## ◆ SetAlignment()

void foxit::pdf::interform::Form::SetAlignment | ( | common::Alignment | alignment | ) |

Set alignment value which is used as document-wide default value.

Alignment is a property for variable text. It is only applicable for text field, list box and combo box, which may contain variable text as their content.
If a text field or list box has its own alignment value, the document-wide default alignment value will be ignored; otherwise, the document-wide default value will be used for the text field or list box.

Parameters

  [in] | alignment | The new default alignment type of variable text. Please refer to values starting from common::e_AlignmentLeft and this should be one of these values. If other values is used to set, common::e_AlignmentLeft will be used by default.

Returns
  None.

## ◆ SetConstructAppearances()

void foxit::pdf::interform::Form::SetConstructAppearances | ( | bool | need_construct | ) |

Set a flag that specifies whether to construct appearances when loading form controls.

Parameters

  [in] | need_construct | true means to construct appearances when loading form controls, and false means not.

Returns
  None.

## ◆ SetDefaultAppearance()

void foxit::pdf::interform::Form::SetDefaultAppearance | ( | const DefaultAppearance & | default_ap | ) |

Set default appearance data.

Parameters

  [in] | default_ap | The new default appearance. flags of input data can be used to decide which information is/are to be updated with the new data; for those no updated data, they will keep to use old data. If text_size of input default appearance data is 0, that means the text size should be calculated automatically.

Returns
  None.

## ◆ SetFieldsInCalculationOrder()

void foxit::pdf::interform::Form::SetFieldsInCalculationOrder | ( | const FieldArray & | field_array | ) |

Set an array of form fields in calculation order.

The calculation order defines the order in which the values of fields will be recalculated when value of any field is changed. Usually, these fields have calculation actions.

Parameters

  [in] | field_array | An array of form fields to specify the new calculation order.

Returns
  None.

## ◆ ValidateFieldName()

bool foxit::pdf::interform::Form::ValidateFieldName | ( | Field::Type | type,
|  | const WString & | field_name
| ) |  |

Validate whether a field name can be used for a new field in specified field type.

This method can be used to check whether a field name can be used for a new field in specified field type. User is recommended to call this function before using function Form::AddControl to add a new field with a new control.

Parameters

  [in] | type | Field type, for which the input field name will be validated.
  [in] | field_name | A string value. It should not be an empty string.

Returns
  true means the input field name is valid for the specified field type, false means not.